
import enum 

class CanMsgType(enum.Enum):
  UNKNWON               = 0x0
  CAN_ENC1              = 0x90
  CAN_ENC2              = 0x91
  CAN_ENC3              = 0x92
  CAN_ENC4              = 0x93
  CAN_SEL               = 0x94
  CAN_KEY_FX            = 0x95
  CAN_KEY_MATRIX        = 0x96
  CAN_KEY_MASTER        = 0x97
  CAN_KEY_VOICE         = 0x98
  CAN_KEY_ESC           = 0x99
  CAN_KEY_ENTER         = 0x9A
  CAN_KEY_ARPSEQ        = 0x9B
  CAN_KEY_DRUM          = 0x9C
  CAN_MIDI_EVENT        = 0x10
  CAN_REQ_VOICE_STATE   = 0x15
  CAN_RSP_VOICE_STATE   = 0x14
  CAN_BROADCAST         = 0x28
  BROADCAST_KIND_PART   = 0xA0
  BROADCAST_KIND_FOCUS  = 0xA1
  BROADCAST_TRACK_MODE  = 0xA2
  BROADCAST_ASSIGN      = 0xA4
  BROADCAST_PANIC       = 0xA5
  BROADCAST_START_STOP  = 0xA7

class EMMsgType(enum.Enum):
  UNKNOWN                      = 0x0
  EM_MSG_TOUCH_EVENT           = 0x100 # Message Event Touch Event (256)
  EM_MSG_KEY                   = 0x101 # Message Event Keyboard (257)
  EM_MSG_ENCODER               = 0x102 # Message Event Encoder (258)
  EM_MSG_FOCUS                 = 0x103 # Message Event Focus (259)
  EM_MSG_POPUP_SHOW            = 0x104 # Message Event Popup Show (260)
  EM_MSG_POPUP_HIDE            = 0x105 # Message Event Popup hide (261)
  EM_MSG_VALUES_CHANGED        = 0x106 # Message Event Values changed (262)
  EM_MSG_TAB_SELECT            = 0x107 # Message Event Tab selected (263)
  EM_MSG_LIST_SELECT           = 0x108 # Message Event List selected (264)
  EM_MSG_PANEL_CTRL            = 0x109 # Message Event Panel Ctrl (265)
  EM_MSG_ON_BUTTON             = 0x10A # Message Event Button On (266)
  EM_MSG_OFF_BUTTON            = 0x10B # Message Event Button Off (267)
  EM_MSG_TABLE_ITEM_SEL        = 0x10C # Message Event Table Item select (268)
  EM_MSG_ACTIVATE_MODUL        = 0x10D # Message Event Activate Module (269)
  EM_MSG_CLOSE_PANEL           = 0x10E # Message Event Close Panel (270)
  EM_MSG_ON_LABEL              = 0x10F # Message Event Label on (271)
  EM_MSG_TICK_EVENT            = 0x110 # Message Event 100ms tick event (272)
  EN_MSG_SET_VALUE             = 0x111 # Message Event Set value (273)
  EM_MSG_ENCODER_EVENT         = 0x112 # Message Event Encoder Event (274)
  EM_MSG_ENCODER_VALUE_CHANGED = 0x113 # Message Event Encoder Value changed (275)
  EM_MSG_ASSIGN_DESTINATION    = 0x114 # Message Event assign destination (276)
  EM_MSG_ASSIGN_SOURCE         = 0x115 # Message Event assign source (277)
  EM_MSG_REPAINT               = 0x116 # Message Event Repaint (278)
  EM_MSG_PART_CHANGED          = 0x117 # Message Event Part changed (279)
  EM_MSG_BPM_QN_TICK           = 0x118 # Message Event BPM QN  tick(280)

class EMEncEvent(enum.Enum):
  UNKNOWN = 0x0
  UP      = 0x82
  DN      = 0X83
  PRESS   = 0x84

class TouchEvent(enum.Enum):
  MOVE     = 0
  PRESS    = 1
  RELEASE  = 2 
  UNKNOWN  = -1

class EMNotifyType(enum.Enum):
  EM_NOTIFY_REPAINT  = 0
  EM_NOTIFY_ENTER    = 1
  EM_NOTIFY_LEAVE    = 2
  EM_NOTIFY_DESELECT = 3
  EM_NOTIFY_SELECT   = 4